﻿using System;

namespace BeepMap {
    partial class WaveGen {
        /*
         * Per-Song Filters
         */

        /*
         * Per-Channel Filters
         */

        /*
         * Per-Note Filters
         */
        private double[] FilterAttack(double[] wave, decimal seconds) {
            double[] samples = wave;
            int numSamples = samples.Length;
            int attackSamples = (int)(seconds * sampleRate);
            if(attackSamples > numSamples) attackSamples = numSamples;
            for(int i = 0; i < attackSamples; i++)
                samples[i] = samples[i] * ((double)i / attackSamples);

            return samples;
        }

        private double[] FilterDecay(double[] wave, decimal seconds) {
            double[] samples = wave;
            int numSamples = samples.Length;
            int decaySamples = (int)(seconds * sampleRate);
            if(decaySamples > numSamples) decaySamples = numSamples;
            for(int i = 0; i < decaySamples; i++)
                samples[samples.Length - i - 1] = samples[samples.Length - i - 1] * ((double)i / decaySamples);

            return samples;
        }
    }
}
